CREATE TABLE fa_book_controls (
    LEASE_CURR_RATE_GAIN_LOSS_FLAG    VARCHAR2(4)  ,
    BOOK_TYPE_CODE                    VARCHAR2(120),
    BOOK_TYPE_NAME                    VARCHAR2(120)    NOT NULL,
    SET_OF_BOOKS_ID                   NUMBER(18, 0)    NOT NULL,
    INITIAL_DATE                      DATE             NOT NULL,
    LAST_DEPRN_RUN_DATE               DATE             NOT NULL,
    AMORTIZE_FLAG                     VARCHAR2(12)     NOT NULL,
    FULLY_RESERVED_FLAG               VARCHAR2(12)     NOT NULL,
    DEPRN_CALENDAR                    VARCHAR2(60)     NOT NULL,
    BOOK_CLASS                        VARCHAR2(60)     NOT NULL,
    GL_POSTING_ALLOWED_FLAG           VARCHAR2(12)     NOT NULL,
    FISCAL_YEAR_NAME                  VARCHAR2(120),
    CURRENT_FISCAL_YEAR               NUMBER(4, 0)     NOT NULL,
    ALLOW_MASS_CHANGES                VARCHAR2(12)     NOT NULL,
    ACCOUNTING_FLEX_STRUCTURE         NUMBER(18, 0)    NOT NULL,
    LAST_UPDATE_DATE                  TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY                   VARCHAR2(256)    NOT NULL,
    PRORATE_CALENDAR                  VARCHAR2(60)     NOT NULL,
    DATE_INEFFECTIVE                  DATE         ,
    DISTRIBUTION_SOURCE_BOOK          VARCHAR2(120),
    COPY_RETIREMENTS_FLAG             VARCHAR2(12)     NOT NULL,
    COPY_ADJUSTMENTS_FLAG             VARCHAR2(12)     NOT NULL,
    DEPRN_REQUEST_ID                  NUMBER(18, 0),
    ALLOW_COST_CEILING                VARCHAR2(12)     NOT NULL,
    ALLOW_DEPRN_EXP_CEILING           VARCHAR2(12)     NOT NULL,
    CREATED_BY                        VARCHAR2(256)    NOT NULL,
    CREATION_DATE                     TIMESTAMP(6)     NOT NULL,
    LAST_UPDATE_LOGIN                 VARCHAR2(128),
    ALLOW_MASS_COPY                   VARCHAR2(12)     NOT NULL,
    ALLOW_PURGE_FLAG                  VARCHAR2(12) ,
    ALLOW_REVAL_FLAG                  VARCHAR2(12)     NOT NULL,
    AMORTIZE_REVAL_RESERVE_FLAG       VARCHAR2(12) ,
    ATTRIBUTE1                        VARCHAR2(600),
    ATTRIBUTE2                        VARCHAR2(600),
    ATTRIBUTE3                        VARCHAR2(600),
    ATTRIBUTE4                        VARCHAR2(600),
    ATTRIBUTE5                        VARCHAR2(600),
    ATTRIBUTE6                        VARCHAR2(600),
    ATTRIBUTE7                        VARCHAR2(600),
    ATTRIBUTE8                        VARCHAR2(600),
    ATTRIBUTE9                        VARCHAR2(600),
    ATTRIBUTE10                       VARCHAR2(600),
    ATTRIBUTE11                       VARCHAR2(600),
    ATTRIBUTE12                       VARCHAR2(600),
    ATTRIBUTE13                       VARCHAR2(600),
    ATTRIBUTE14                       VARCHAR2(600),
    ATTRIBUTE15                       VARCHAR2(600),
    ATTRIBUTE_CATEGORY_CODE           VARCHAR2(120),
    CAPITAL_GAIN_THRESHOLD            NUMBER       ,
    COPY_SALVAGE_VALUE_FLAG           VARCHAR2(12)     NOT NULL,
    COST_OF_REMOVAL_CLEARING_ACCT     VARCHAR2(100)    NOT NULL,
    COST_OF_REMOVAL_GAIN_ACCT         VARCHAR2(100)    NOT NULL,
    COST_OF_REMOVAL_LOSS_ACCT         VARCHAR2(100)    NOT NULL,
    DEFAULT_LIFE_EXTENSION_CEILING    NUMBER       ,
    DEFAULT_LIFE_EXTENSION_FACTOR     NUMBER       ,
    DEFAULT_MAX_FULLY_RSVD_REVALS     NUMBER(18, 0),
    DEFAULT_REVAL_FULLY_RSVD_FLAG     VARCHAR2(12) ,
    DEFERRED_DEPRN_EXPENSE_ACCT       VARCHAR2(100)    NOT NULL,
    DEFERRED_DEPRN_RESERVE_ACCT       VARCHAR2(100)    NOT NULL,
    DEPRN_ALLOCATION_CODE             VARCHAR2(4)      NOT NULL,
    DEPRN_STATUS                      VARCHAR2(4)  ,
    INITIAL_PERIOD_COUNTER            NUMBER(18, 0)    NOT NULL,
    LAST_MASS_COPY_PERIOD_COUNTER     NUMBER(18, 0),
    LAST_PERIOD_COUNTER               NUMBER(18, 0)    NOT NULL,
    LAST_PURGE_PERIOD_COUNTER         NUMBER(18, 0),
    MASS_COPY_SOURCE_BOOK             VARCHAR2(120),
    MASS_REQUEST_ID                   NUMBER(18, 0),
    NBV_AMOUNT_THRESHOLD              NUMBER       ,
    NBV_FRACTION_THRESHOLD            NUMBER       ,
    NBV_RETIRED_GAIN_ACCT             VARCHAR2(100)    NOT NULL,
    NBV_RETIRED_LOSS_ACCT             VARCHAR2(100)    NOT NULL,
    PROCEEDS_OF_SALE_CLEARING_ACCT    VARCHAR2(100)    NOT NULL,
    PROCEEDS_OF_SALE_GAIN_ACCT        VARCHAR2(100)    NOT NULL,
    PROCEEDS_OF_SALE_LOSS_ACCT        VARCHAR2(100)    NOT NULL,
    REVAL_DEPRN_RESERVE_FLAG          VARCHAR2(12) ,
    REVAL_RSV_RETIRED_GAIN_ACCT       VARCHAR2(100),
    REVAL_RSV_RETIRED_LOSS_ACCT       VARCHAR2(100),
    IMMEDIATE_COPY_FLAG               VARCHAR2(12) ,
    DEPR_FIRST_YEAR_RET_FLAG          VARCHAR2(12)     NOT NULL,
    FLEXBUILDER_DEFAULTS_CCID         NUMBER(18, 0)    NOT NULL,
    RETIRE_REVAL_RESERVE_FLAG         VARCHAR2(12) ,
    COPY_ADDITIONS_FLAG               VARCHAR2(12)     NOT NULL,
    USE_PERCENT_SALVAGE_VALUE_FLAG    VARCHAR2(12) ,
    MC_SOURCE_FLAG                    VARCHAR2(4)  ,
    REVAL_YTD_DEPRN_FLAG              VARCHAR2(12) ,
    ALLOW_CIP_ASSETS_FLAG             VARCHAR2(12) ,
    ALLOW_GROUP_DEPRN_FLAG            VARCHAR2(4)  ,
    ALLOW_CIP_DEP_GROUP_FLAG          VARCHAR2(4)  ,
    ALLOW_INTERCO_GROUP_FLAG          VARCHAR2(4)  ,
    COPY_GROUP_ASSIGNMENT_FLAG        VARCHAR2(4)  ,
    COPY_GROUP_ADDITION_FLAG          VARCHAR2(4)  ,
    ALLOW_CIP_MEMBER_FLAG             VARCHAR2(4)  ,
    ALLOW_MEMBER_TRACKING_FLAG        VARCHAR2(4)  ,
    ALLOW_BACKDATED_TRANSFERS_FLAG    VARCHAR2(4)  ,
    ALLOW_COST_SIGN_CHANGE_FLAG       VARCHAR2(4)  ,
    CREATE_ACCOUNTING_REQUEST_ID      NUMBER(18, 0),
    OBJECT_VERSION_NUMBER             NUMBER(9, 0)     NOT NULL,
    ALLOW_BONUS_DEPRN_FLAG            VARCHAR2(4)  ,
    ALLOW_IMPAIRMENT_FLAG             VARCHAR2(4)  ,
    ITC_ALLOWED_FLAG                  VARCHAR2(12) ,
    SORP_ENABLED_FLAG                 VARCHAR2(4)  ,
    ALLOW_DEPRN_ADJUSTMENTS           VARCHAR2(12) ,
    DEPRN_ADJUSTMENT_ACCT             VARCHAR2(100),
    ROUND_ANNUAL_DEPRECIATION         VARCHAR2(120),
    COPY_ALL_COST_ADJUSTMENTS_FLAG    VARCHAR2(4)  ,
    DEFAULT_DPIS_TO_INV_DATE_FLAG     VARCHAR2(4)  ,
    USE_NBV_THRESHOLD_FLAG            VARCHAR2(4)  ,
    COPY_AMORT_ADAJ_EXP_FLAG          VARCHAR2(4)  ,
    GLOBAL_ATTRIBUTE_CATEGORY         VARCHAR2(120),
    GLOBAL_ATTRIBUTE1                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE2                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE3                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE4                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE5                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE6                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE7                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE8                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE9                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE10                VARCHAR2(600),
    GLOBAL_ATTRIBUTE11                VARCHAR2(600),
    GLOBAL_ATTRIBUTE12                VARCHAR2(600),
    GLOBAL_ATTRIBUTE13                VARCHAR2(600),
    GLOBAL_ATTRIBUTE14                VARCHAR2(600),
    GLOBAL_ATTRIBUTE15                VARCHAR2(600),
    GLOBAL_ATTRIBUTE16                VARCHAR2(600),
    GLOBAL_ATTRIBUTE17                VARCHAR2(600),
    GLOBAL_ATTRIBUTE18                VARCHAR2(600),
    GLOBAL_ATTRIBUTE19                VARCHAR2(600),
    GLOBAL_ATTRIBUTE20                VARCHAR2(600),
    GLOBAL_ATTRIBUTE_NUMBER1          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER2          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER3          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER4          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER5          NUMBER       ,
    GLOBAL_ATTRIBUTE_DATE1            DATE         ,
    GLOBAL_ATTRIBUTE_DATE2            DATE         ,
    GLOBAL_ATTRIBUTE_DATE3            DATE         ,
    GLOBAL_ATTRIBUTE_DATE4            DATE         ,
    GLOBAL_ATTRIBUTE_DATE5            DATE         ,
    LAST_CREATE_MASS_ADDITIONS_ID     NUMBER(18, 0),
    LAST_POST_MASS_ADDITIONS_ID       NUMBER(18, 0),
    COPY_GROUP_CHANGE_FLAG            VARCHAR2(4)  ,
    PREVENT_PRIOR_PERIOD_TXNS_FLAG    VARCHAR2(4)  ,
    ALLOW_DEPRN_OVERRIDE_FLAG         VARCHAR2(4)  ,
    ALLOW_FUND_ACCOUNTING_FLAG        VARCHAR2(4)  ,
    ALLOW_COST_BASED_REVAL_FLAG       VARCHAR2(4)  ,
    ALLOW_NBV_BASED_REVAL_FLAG        VARCHAR2(4)  ,
    DEFAULT_PERIOD_END_REVAL_FLAG     VARCHAR2(4)  ,
    ALLOW_UNALLOCATED_LINES_FLAG      VARCHAR2(4)  ,
    SUPPRESS_INV_AUTO_MERGE_FLAG      VARCHAR2(4)  ,
    ALLOW_DIRECT_TAX_ADDITION_FLAG    VARCHAR2(4)  ,
    ALLOW_TAX_DISTRIBUTIONS_FLAG      VARCHAR2(4)  ,
    BOOK_TYPE_MIGRATION_FLAG          VARCHAR2(4)  ,
    COPY_TRANSFERS_FLAG               VARCHAR2(4)  ,
    REQUIRE_LOCATION_FLAG             VARCHAR2(4)  ,
    TRACK_SOURCE_LINES_IN_TAX_FLAG    VARCHAR2(4)  ,
    CAP_THRESHOLD_TYPE                VARCHAR2(120),
    CAP_THRESHOLD_AMOUNT              NUMBER       ,
    LOW_VALUE_THRESHOLD_AMOUNT        NUMBER       ,
    ALLOW_TRANS_CONVENTION_FLAG       VARCHAR2(4)  ,
    ADVANCED_OPTIONS_ENABLED_FLAG     VARCHAR2(4)  ,
    ALLOW_PHYSICAL_INVENTORY_FLAG     VARCHAR2(4)  ,
    ALLOW_LEASES_FLAG                 VARCHAR2(4)  ,
    LEASE_EXPENSE_RUN_FLAG            VARCHAR2(4)  ,
    COPY_LEASE_ASSETS_FLAG            VARCHAR2(4)  ,
    COPY_LEASE_SCHEDULES_FLAG         VARCHAR2(4)  ,
    LAST_LEASE_EXPENSE_RUN_DATE       DATE         ,
    LEASE_MIGRATION_FLAG              VARCHAR2(4)  ,
    CREATE_ACCOUNTING_RUN_DATE        TIMESTAMP(6) ,
    LAST_DEPRECIATION_RUN_DATE        TIMESTAMP(6) ,
    NON_SALE_GAIN_ACCT                VARCHAR2(100),
    USE_FIRST_DATE_AS_TRX_DATE        VARCHAR2(4)  ,
    ALLOW_UK_GOVERNMENT_REVAL_FLAG    VARCHAR2(4)  ,
    INDEX_REVAL_PERIOD_NUM            NUMBER(3, 0) ,
    ATTRIBUTE_NUMBER1                 NUMBER       ,
    ATTRIBUTE_NUMBER2                 NUMBER       ,
    ATTRIBUTE_NUMBER3                 NUMBER       ,
    ATTRIBUTE_NUMBER4                 NUMBER       ,
    ATTRIBUTE_NUMBER5                 NUMBER       ,
    ATTRIBUTE_DATE1                   DATE         ,
    ATTRIBUTE_DATE2                   DATE         ,
    ATTRIBUTE_DATE3                   DATE         ,
    ATTRIBUTE_DATE4                   DATE         ,
    ATTRIBUTE_DATE5                   DATE         ,
    ADDITIONS_APPROVAL_FLAG           VARCHAR2(4)  ,
    ADJUSTMENTS_APPROVAL_FLAG         VARCHAR2(4)  ,
    TRANSFERS_APPROVAL_FLAG           VARCHAR2(4)  ,
    RETIREMENTS_APPROVAL_FLAG         VARCHAR2(4)  ,
    AP_CLEARING_BSV_CHECK_FLAG        VARCHAR2(4)      NOT NULL,
    AP_CLEARING_CC_CHECK_FLAG         VARCHAR2(4)      NOT NULL,
    AP_CLEARING_NA_CHECK_FLAG         VARCHAR2(4)      NOT NULL,
    AP_CLEARING_BSV2_CHECK_FLAG       VARCHAR2(4)  ,
    ALLOW_BOOK_TRANSFER_FLAG          VARCHAR2(4)  ,
    AP_INTERCOMPANY_ACCT              VARCHAR2(100),
    AR_INTERCOMPANY_ACCT              VARCHAR2(100),
    CAP_THRESHOLD_CURRENCY_CODE       VARCHAR2(60) ,
    CAP_THRESHOLD_RATE_TYPE           VARCHAR2(120),
    BOOK_CONTROL_ID                   NUMBER(18, 0),
    ALLOW_ANNUITY_DEPRN_FLAG          VARCHAR2(4)  ,
    ENABLE_AP_AUTOPOST_FLAG           VARCHAR2(4)  ,
    DEFAULT_CATEGORY_FLAG             VARCHAR2(4)  ,
    BOOK_CONTROL_ID                   NUMBER(18, 0),
    BOOK_TYPE_CODE                    VARCHAR2(120),
    BOOK_TYPE_NAME                    VARCHAR2(120)    NOT NULL,
    SET_OF_BOOKS_ID                   NUMBER(18, 0)    NOT NULL,
    INITIAL_DATE                      DATE             NOT NULL,
    LAST_DEPRN_RUN_DATE               DATE             NOT NULL,
    AMORTIZE_FLAG                     VARCHAR2(12)     NOT NULL,
    FULLY_RESERVED_FLAG               VARCHAR2(12)     NOT NULL,
    DEPRN_CALENDAR                    VARCHAR2(60)     NOT NULL,
    BOOK_CLASS                        VARCHAR2(60)     NOT NULL,
    GL_POSTING_ALLOWED_FLAG           VARCHAR2(12)     NOT NULL,
    FISCAL_YEAR_NAME                  VARCHAR2(120),
    CURRENT_FISCAL_YEAR               NUMBER(4, 0)     NOT NULL,
    ALLOW_MASS_CHANGES                VARCHAR2(12)     NOT NULL,
    ACCOUNTING_FLEX_STRUCTURE         NUMBER(18, 0)    NOT NULL,
    LAST_UPDATE_DATE                  TIMESTAMP(6)     NOT NULL,
    LAST_UPDATED_BY                   VARCHAR2(256)    NOT NULL,
    PRORATE_CALENDAR                  VARCHAR2(60)     NOT NULL,
    DATE_INEFFECTIVE                  DATE         ,
    DISTRIBUTION_SOURCE_BOOK          VARCHAR2(120),
    COPY_RETIREMENTS_FLAG             VARCHAR2(12)     NOT NULL,
    COPY_ADJUSTMENTS_FLAG             VARCHAR2(12)     NOT NULL,
    DEPRN_REQUEST_ID                  NUMBER(18, 0),
    ALLOW_COST_CEILING                VARCHAR2(12)     NOT NULL,
    ALLOW_DEPRN_EXP_CEILING           VARCHAR2(12)     NOT NULL,
    CREATED_BY                        VARCHAR2(256)    NOT NULL,
    CREATION_DATE                     TIMESTAMP(6)     NOT NULL,
    LAST_UPDATE_LOGIN                 VARCHAR2(128),
    ALLOW_MASS_COPY                   VARCHAR2(12)     NOT NULL,
    ALLOW_PURGE_FLAG                  VARCHAR2(12) ,
    ALLOW_REVAL_FLAG                  VARCHAR2(12)     NOT NULL,
    AMORTIZE_REVAL_RESERVE_FLAG       VARCHAR2(12) ,
    ATTRIBUTE1                        VARCHAR2(600),
    ATTRIBUTE2                        VARCHAR2(600),
    ATTRIBUTE3                        VARCHAR2(600),
    ATTRIBUTE4                        VARCHAR2(600),
    ATTRIBUTE5                        VARCHAR2(600),
    ATTRIBUTE6                        VARCHAR2(600),
    ATTRIBUTE7                        VARCHAR2(600),
    ATTRIBUTE8                        VARCHAR2(600),
    ATTRIBUTE9                        VARCHAR2(600),
    ATTRIBUTE10                       VARCHAR2(600),
    ATTRIBUTE11                       VARCHAR2(600),
    ATTRIBUTE12                       VARCHAR2(600),
    ATTRIBUTE13                       VARCHAR2(600),
    ATTRIBUTE14                       VARCHAR2(600),
    ATTRIBUTE15                       VARCHAR2(600),
    ATTRIBUTE_CATEGORY_CODE           VARCHAR2(120),
    CAPITAL_GAIN_THRESHOLD            NUMBER       ,
    COPY_SALVAGE_VALUE_FLAG           VARCHAR2(12)     NOT NULL,
    COST_OF_REMOVAL_CLEARING_ACCT     VARCHAR2(100)    NOT NULL,
    COST_OF_REMOVAL_GAIN_ACCT         VARCHAR2(100)    NOT NULL,
    COST_OF_REMOVAL_LOSS_ACCT         VARCHAR2(100)    NOT NULL,
    DEFAULT_LIFE_EXTENSION_CEILING    NUMBER       ,
    DEFAULT_LIFE_EXTENSION_FACTOR     NUMBER       ,
    DEFAULT_MAX_FULLY_RSVD_REVALS     NUMBER(18, 0),
    DEFAULT_REVAL_FULLY_RSVD_FLAG     VARCHAR2(12) ,
    DEFERRED_DEPRN_EXPENSE_ACCT       VARCHAR2(100)    NOT NULL,
    DEFERRED_DEPRN_RESERVE_ACCT       VARCHAR2(100)    NOT NULL,
    DEPRN_ALLOCATION_CODE             VARCHAR2(4)      NOT NULL,
    DEPRN_STATUS                      VARCHAR2(4)  ,
    INITIAL_PERIOD_COUNTER            NUMBER(18, 0)    NOT NULL,
    LAST_MASS_COPY_PERIOD_COUNTER     NUMBER(18, 0),
    LAST_PERIOD_COUNTER               NUMBER(18, 0)    NOT NULL,
    LAST_PURGE_PERIOD_COUNTER         NUMBER(18, 0),
    MASS_COPY_SOURCE_BOOK             VARCHAR2(120),
    MASS_REQUEST_ID                   NUMBER(18, 0),
    NBV_AMOUNT_THRESHOLD              NUMBER       ,
    NBV_FRACTION_THRESHOLD            NUMBER       ,
    NBV_RETIRED_GAIN_ACCT             VARCHAR2(100)    NOT NULL,
    NBV_RETIRED_LOSS_ACCT             VARCHAR2(100)    NOT NULL,
    PROCEEDS_OF_SALE_CLEARING_ACCT    VARCHAR2(100)    NOT NULL,
    PROCEEDS_OF_SALE_GAIN_ACCT        VARCHAR2(100)    NOT NULL,
    PROCEEDS_OF_SALE_LOSS_ACCT        VARCHAR2(100)    NOT NULL,
    REVAL_DEPRN_RESERVE_FLAG          VARCHAR2(12) ,
    REVAL_RSV_RETIRED_GAIN_ACCT       VARCHAR2(100),
    REVAL_RSV_RETIRED_LOSS_ACCT       VARCHAR2(100),
    IMMEDIATE_COPY_FLAG               VARCHAR2(12) ,
    DEPR_FIRST_YEAR_RET_FLAG          VARCHAR2(12)     NOT NULL,
    FLEXBUILDER_DEFAULTS_CCID         NUMBER(18, 0)    NOT NULL,
    RETIRE_REVAL_RESERVE_FLAG         VARCHAR2(12) ,
    COPY_ADDITIONS_FLAG               VARCHAR2(12)     NOT NULL,
    USE_PERCENT_SALVAGE_VALUE_FLAG    VARCHAR2(12) ,
    MC_SOURCE_FLAG                    VARCHAR2(4)  ,
    REVAL_YTD_DEPRN_FLAG              VARCHAR2(12) ,
    ALLOW_CIP_ASSETS_FLAG             VARCHAR2(12) ,
    ALLOW_GROUP_DEPRN_FLAG            VARCHAR2(4)  ,
    ALLOW_CIP_DEP_GROUP_FLAG          VARCHAR2(4)  ,
    ALLOW_INTERCO_GROUP_FLAG          VARCHAR2(4)  ,
    COPY_GROUP_ASSIGNMENT_FLAG        VARCHAR2(4)  ,
    COPY_GROUP_ADDITION_FLAG          VARCHAR2(4)  ,
    ALLOW_CIP_MEMBER_FLAG             VARCHAR2(4)  ,
    ALLOW_MEMBER_TRACKING_FLAG        VARCHAR2(4)  ,
    ALLOW_BACKDATED_TRANSFERS_FLAG    VARCHAR2(4)  ,
    ALLOW_COST_SIGN_CHANGE_FLAG       VARCHAR2(4)  ,
    CREATE_ACCOUNTING_REQUEST_ID      NUMBER(18, 0),
    OBJECT_VERSION_NUMBER             NUMBER(9, 0)     NOT NULL,
    ALLOW_BONUS_DEPRN_FLAG            VARCHAR2(4)  ,
    ALLOW_IMPAIRMENT_FLAG             VARCHAR2(4)  ,
    ITC_ALLOWED_FLAG                  VARCHAR2(12) ,
    SORP_ENABLED_FLAG                 VARCHAR2(4)  ,
    ALLOW_DEPRN_ADJUSTMENTS           VARCHAR2(12) ,
    DEPRN_ADJUSTMENT_ACCT             VARCHAR2(100),
    ROUND_ANNUAL_DEPRECIATION         VARCHAR2(120),
    COPY_ALL_COST_ADJUSTMENTS_FLAG    VARCHAR2(4)  ,
    DEFAULT_DPIS_TO_INV_DATE_FLAG     VARCHAR2(4)  ,
    USE_NBV_THRESHOLD_FLAG            VARCHAR2(4)  ,
    COPY_AMORT_ADAJ_EXP_FLAG          VARCHAR2(4)  ,
    GLOBAL_ATTRIBUTE_CATEGORY         VARCHAR2(120),
    GLOBAL_ATTRIBUTE1                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE2                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE3                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE4                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE5                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE6                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE7                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE8                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE9                 VARCHAR2(600),
    GLOBAL_ATTRIBUTE10                VARCHAR2(600),
    GLOBAL_ATTRIBUTE11                VARCHAR2(600),
    GLOBAL_ATTRIBUTE12                VARCHAR2(600),
    GLOBAL_ATTRIBUTE13                VARCHAR2(600),
    GLOBAL_ATTRIBUTE14                VARCHAR2(600),
    GLOBAL_ATTRIBUTE15                VARCHAR2(600),
    GLOBAL_ATTRIBUTE16                VARCHAR2(600),
    GLOBAL_ATTRIBUTE17                VARCHAR2(600),
    GLOBAL_ATTRIBUTE18                VARCHAR2(600),
    GLOBAL_ATTRIBUTE19                VARCHAR2(600),
    GLOBAL_ATTRIBUTE20                VARCHAR2(600),
    GLOBAL_ATTRIBUTE_NUMBER1          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER2          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER3          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER4          NUMBER       ,
    GLOBAL_ATTRIBUTE_NUMBER5          NUMBER       ,
    GLOBAL_ATTRIBUTE_DATE1            DATE         ,
    GLOBAL_ATTRIBUTE_DATE2            DATE         ,
    GLOBAL_ATTRIBUTE_DATE3            DATE         ,
    GLOBAL_ATTRIBUTE_DATE4            DATE         ,
    GLOBAL_ATTRIBUTE_DATE5            DATE         ,
    LAST_CREATE_MASS_ADDITIONS_ID     NUMBER(18, 0),
    LAST_POST_MASS_ADDITIONS_ID       NUMBER(18, 0),
    COPY_GROUP_CHANGE_FLAG            VARCHAR2(4)  ,
    PREVENT_PRIOR_PERIOD_TXNS_FLAG    VARCHAR2(4)  ,
    ALLOW_DEPRN_OVERRIDE_FLAG         VARCHAR2(4)  ,
    ALLOW_FUND_ACCOUNTING_FLAG        VARCHAR2(4)  ,
    ALLOW_COST_BASED_REVAL_FLAG       VARCHAR2(4)  ,
    ALLOW_NBV_BASED_REVAL_FLAG        VARCHAR2(4)  ,
    DEFAULT_PERIOD_END_REVAL_FLAG     VARCHAR2(4)  ,
    ALLOW_UNALLOCATED_LINES_FLAG      VARCHAR2(4)  ,
    SUPPRESS_INV_AUTO_MERGE_FLAG      VARCHAR2(4)  ,
    ALLOW_DIRECT_TAX_ADDITION_FLAG    VARCHAR2(4)  ,
    ALLOW_TAX_DISTRIBUTIONS_FLAG      VARCHAR2(4)  ,
    BOOK_TYPE_MIGRATION_FLAG          VARCHAR2(4)  ,
    COPY_TRANSFERS_FLAG               VARCHAR2(4)  ,
    REQUIRE_LOCATION_FLAG             VARCHAR2(4)  ,
    TRACK_SOURCE_LINES_IN_TAX_FLAG    VARCHAR2(4)  ,
    CAP_THRESHOLD_TYPE                VARCHAR2(120),
    CAP_THRESHOLD_AMOUNT              NUMBER       ,
    LOW_VALUE_THRESHOLD_AMOUNT        NUMBER       ,
    ALLOW_TRANS_CONVENTION_FLAG       VARCHAR2(4)  ,
    ADVANCED_OPTIONS_ENABLED_FLAG     VARCHAR2(4)  ,
    ALLOW_PHYSICAL_INVENTORY_FLAG     VARCHAR2(4)  ,
    LEASE_CURR_RATE_GAIN_LOSS_FLAG    VARCHAR2(4)  ,
    ALLOW_LEASES_FLAG                 VARCHAR2(4)  ,
    LEASE_EXPENSE_RUN_FLAG            VARCHAR2(4)  ,
    COPY_LEASE_ASSETS_FLAG            VARCHAR2(4)  ,
    COPY_LEASE_SCHEDULES_FLAG         VARCHAR2(4)  ,
    LAST_LEASE_EXPENSE_RUN_DATE       DATE         ,
    LEASE_MIGRATION_FLAG              VARCHAR2(4)  ,
    CREATE_ACCOUNTING_RUN_DATE        TIMESTAMP(6) ,
    LAST_DEPRECIATION_RUN_DATE        TIMESTAMP(6) ,
    NON_SALE_GAIN_ACCT                VARCHAR2(100),
    USE_FIRST_DATE_AS_TRX_DATE        VARCHAR2(4)  ,
    ALLOW_UK_GOVERNMENT_REVAL_FLAG    VARCHAR2(4)  ,
    INDEX_REVAL_PERIOD_NUM            NUMBER(3, 0) ,
    ATTRIBUTE_NUMBER1                 NUMBER       ,
    ATTRIBUTE_NUMBER2                 NUMBER       ,
    ATTRIBUTE_NUMBER3                 NUMBER       ,
    ATTRIBUTE_NUMBER4                 NUMBER       ,
    ATTRIBUTE_NUMBER5                 NUMBER       ,
    ATTRIBUTE_DATE1                   DATE         ,
    ATTRIBUTE_DATE2                   DATE         ,
    ATTRIBUTE_DATE3                   DATE         ,
    ATTRIBUTE_DATE4                   DATE         ,
    ATTRIBUTE_DATE5                   DATE         ,
    ADDITIONS_APPROVAL_FLAG           VARCHAR2(4)  ,
    ADJUSTMENTS_APPROVAL_FLAG         VARCHAR2(4)  ,
    TRANSFERS_APPROVAL_FLAG           VARCHAR2(4)  ,
    RETIREMENTS_APPROVAL_FLAG         VARCHAR2(4)  ,
    AP_CLEARING_BSV_CHECK_FLAG        VARCHAR2(4)      NOT NULL,
    AP_CLEARING_CC_CHECK_FLAG         VARCHAR2(4)      NOT NULL,
    AP_CLEARING_NA_CHECK_FLAG         VARCHAR2(4)      NOT NULL,
    ALLOW_BOOK_TRANSFER_FLAG          VARCHAR2(4)  ,
    AP_INTERCOMPANY_ACCT              VARCHAR2(100),
    AR_INTERCOMPANY_ACCT              VARCHAR2(100),
    CAP_THRESHOLD_CURRENCY_CODE       VARCHAR2(60) ,
    CAP_THRESHOLD_RATE_TYPE           VARCHAR2(120),
    ALLOW_ANNUITY_DEPRN_FLAG          VARCHAR2(4)  ,
    AP_CLEARING_BSV2_CHECK_FLAG       VARCHAR2(4)  ,
    ENABLE_AP_AUTOPOST_FLAG           VARCHAR2(4)  ,
    DEFAULT_CATEGORY_FLAG             VARCHAR2(4)  ,
    CONSTRAINT pk_fa_book_controls PRIMARY KEY (BOOK_TYPE_CODE, BOOK_TYPE_CODE)
);
